/*
	
	HelloWindow.h
	
	Copyright 1997 Be Incorporated, All Rights Reserved.
	
*/

class PsiNCPWindow : public BWindow
{
public:
				PsiNCPWindow(BRect frame); 
				~PsiNCPWindow(void); 
		bool	QuitRequested(void);
		void	MessageReceived(BMessage *msg);
		void	SavePreferences(void);			// Diese Funktion speicher die Einstellungen!
		void	LoadPreferences(void);			// Diese Funktion lädt die Einstellungen!

private:
	BSerialPort	*Port;							// Der Zeiger auf den einen BSerialPort
	BButton		*connect, *discon;				// Zwei Zeiger auf die Buttons connect und disconnect
	BCheckBox	*debug_box;						// Zeiger auf den Schalter der DebugBox
	data_rate	DataRate;						// Enthält aktuelle Datenrate
	char		PortName[B_FILE_NAME_LENGTH];	// Enthält den Devicenamen
	char		MountPoint[B_FILE_NAME_LENGTH];	// Enthält den Pfadnamen wo gemountet werden soll!
	bool		connected;						// true = Verbindung hergestellt, Fenster darf nicht geschlossen werden!
	bool		debug;							// true, dann wird für jeden Port eine Datei mitgeschrieben!
};

class PsiNCPView : public BView 
{
public:
	PsiNCPView(BRect frame, const char *name, const char *text); 
};

class SerialView : public BView
{
public:
	SerialView(BRect rect, const char *name, BSerialPort *Port, const char *dev, const data_rate dr);
};


