// Diese Funktion startet den RFSV-Server auf dem PSION und bei Erfolg wird das Filesystem "psionfs" gemountet!
// Diese Funktion muß als eigenener thread gestartet werden, damit er auf das Ergebnis warten kann!

// Das muß alles noch ausgelagert werden. Derzeit gefällt es mir hier nicht so sehr. Es fehlt
// das freigeben der Semaphore und das unmounten!

#include "ReadSerial.h"
#include "thread.h"
#include "messages.h"
#include "debug.h"
#include "StartRFSVServer.h"

int32 StartRFSVServer ( void* dummy) {

	int			result;
	int32		msg;
	size_t		r_byte;
	MNT_INFO	mnt_info;
	char		text[128];
	
	mnt_info.pid_read = create_port(50, READ_PORT);		// Über diesen Port kommen die Antworten vom PSION
	mnt_info.pid_write = pid_o;
	
	write_port(mnt_info.pid_write, PSION_SSERV, START_RFSV_SERVER , sizeof(START_RFSV_SERVER));
	r_byte = read_port_etc(mnt_info.pid_read, &msg, text, 128, B_TIMEOUT, 10000000L);	/* 10 Sekunde Timeout!	*/
	if (r_byte >= B_NO_ERROR) {				// Mounten nur durchführen, wenn nach 10 Sekunden alles klar ist!
		mnt_info.cid = msg & CID_MASK;

		mnt_info.sem = create_sem(1, "RFSV-NCP-Write");	// Wir brauchen eine Semaphore um das Schreiben auf die Schnittstelle zu serialisieren!
		if (mnt_info.sem >= B_NO_ERROR) {
			strcpy(mnt_info.device, "M:");			// Es geht ums Laufwerk M:
			printf("Starten des Mounten....\n");	// Diese Funktion erzeugt auch einen eigenen Port!
			result = mount ("psionfs", MOUNT_POINT, NULL, 0, &mnt_info, sizeof(mnt_info) );
			printf("Mount rückgabewert: %s\n", strerror(result));
		}
	}
	return 0;
}

